Create or update entity integration configuration

Note: This endpoint is in preview and is subject to change. If you have any feedback, contact Datadog support.

PUT https://api.ap1.datadoghq.com/api/v2/idp/entity_integrations/{integration_id}https://api.ap2.datadoghq.com/api/v2/idp/entity_integrations/{integration_id}https://api.datadoghq.eu/api/v2/idp/entity_integrations/{integration_id}https://api.ddog-gov.com/api/v2/idp/entity_integrations/{integration_id}https://api.us2.ddog-gov.com/api/v2/idp/entity_integrations/{integration_id}https://api.uk1.datadoghq.com/api/v2/idp/entity_integrations/{integration_id}https://api.datadoghq.com/api/v2/idp/entity_integrations/{integration_id}https://api.us3.datadoghq.com/api/v2/idp/entity_integrations/{integration_id}https://api.us5.datadoghq.com/api/v2/idp/entity_integrations/{integration_id}

概要

Create or replace the configuration for a given integration in the caller’s organization. The shape of data.attributes.config depends on the integration:

  • For github: config must contain an enabled_repos array of objects with hostname, github_org_name, and repo_name.
  • For jira: config must contain an enabled_projects array of objects with hostname, account_id, and project_key.
  • For pagerduty: config must contain an accounts array of objects with a required enabled boolean and an optional subdomain string.
This endpoint requires the integrations_read permission.

引数

パスパラメーター

名前

タイプ

説明

integration_id [required]

string

The identifier of the integration whose configuration is being managed. Supported values are github, jira, and pagerduty.

リクエスト

Body Data (required)

Expand All

フィールド

タイプ

説明

data [required]

object

JSON:API resource object used in a request to create or update an entity integration configuration.

attributes [required]

object

Attributes used to create or update an entity integration configuration.

config [required]

object

Integration-specific configuration payload. The shape of this object depends on the integration identified by the path parameter. For github, the object must contain an enabled_repos array. For jira, it must contain an enabled_projects array. For pagerduty, it must contain an accounts array.

type [required]

enum

JSON:API resource type for the entity integration configuration create or update request. Always entity_integration_config_requests. Allowed enum values: entity_integration_config_requests

default: entity_integration_config_requests

{
  "data": {
    "attributes": {
      "config": {
        "enabled_repos": [
          {
            "github_org_name": "myorg",
            "hostname": "github.com",
            "repo_name": "myrepo"
          }
        ]
      }
    },
    "type": "entity_integration_config_requests"
  }
}

応答

OK

Expand All

フィールド

タイプ

説明

data [required]

object

JSON:API resource object for an entity integration configuration.

attributes [required]

object

The organization ID, integration identifier, and integration-specific configuration payload for an entity integration configuration.

config [required]

object

Integration-specific configuration payload. The shape of this object depends on the integration identified by the path parameter. For github, the object must contain an enabled_repos array. For jira, it must contain an enabled_projects array. For pagerduty, it must contain an accounts array.

integration_id [required]

string

The identifier of the integration this configuration applies to (for example, github, jira, or pagerduty).

org_id [required]

int64

The Datadog organization identifier that owns this configuration.

id [required]

string

Unique identifier of the entity integration configuration.

type [required]

enum

JSON:API resource type for an entity integration configuration. Always entity_integration_configs. Allowed enum values: entity_integration_configs

default: entity_integration_configs

{
  "data": {
    "attributes": {
      "config": {
        "enabled_repos": [
          {
            "github_org_name": "myorg",
            "hostname": "github.com",
            "repo_name": "myrepo"
          }
        ]
      },
      "integration_id": "github",
      "org_id": 1234
    },
    "id": "01HJABCD12345678ABCDEFGHIJ",
    "type": "entity_integration_configs"
  }
}

JSON:API document containing a single entity integration configuration resource.

Expand All

フィールド

タイプ

説明

data [required]

object

JSON:API resource object for an entity integration configuration.

attributes [required]

object

The organization ID, integration identifier, and integration-specific configuration payload for an entity integration configuration.

config [required]

object

Integration-specific configuration payload. The shape of this object depends on the integration identified by the path parameter. For github, the object must contain an enabled_repos array. For jira, it must contain an enabled_projects array. For pagerduty, it must contain an accounts array.

integration_id [required]

string

The identifier of the integration this configuration applies to (for example, github, jira, or pagerduty).

org_id [required]

int64

The Datadog organization identifier that owns this configuration.

id [required]

string

Unique identifier of the entity integration configuration.

type [required]

enum

JSON:API resource type for an entity integration configuration. Always entity_integration_configs. Allowed enum values: entity_integration_configs

default: entity_integration_configs

{
  "data": {
    "attributes": {
      "config": {
        "enabled_repos": [
          {
            "github_org_name": "myorg",
            "hostname": "github.com",
            "repo_name": "myrepo"
          }
        ]
      },
      "integration_id": "github",
      "org_id": 1234
    },
    "id": "01HJABCD12345678ABCDEFGHIJ",
    "type": "entity_integration_configs"
  }
}

Bad Request

API error response.

Expand All

フィールド

タイプ

説明

errors [required]

[object]

A list of errors.

detail

string

A human-readable explanation specific to this occurrence of the error.

meta

object

Non-standard meta-information about the error

source

object

References to the source of the error.

header

string

A string indicating the name of a single request header which caused the error.

parameter

string

A string indicating which URI query parameter caused the error.

pointer

string

A JSON pointer to the value in the request document that caused the error.

status

string

Status code of the response.

title

string

Short human-readable summary of the error.

{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}

Not Authorized

API error response.

Expand All

フィールド

タイプ

説明

errors [required]

[string]

A list of errors.

{
  "errors": [
    "Bad Request"
  ]
}

Too many requests

API error response.

Expand All

フィールド

タイプ

説明

errors [required]

[string]

A list of errors.

{
  "errors": [
    "Bad Request"
  ]
}

コード例

                  ## GitHub integration configuration
# 

# Path parameters
export integration_id="github"
# Use a Personal Access Token or Service Access Token
export DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>"

# Curl command
curl -X PUT "https://api.ap1.datadoghq.com"https://api.ap2.datadoghq.com"https://api.datadoghq.eu"https://api.ddog-gov.com"https://api.us2.ddog-gov.com"https://api.uk1.datadoghq.com"https://api.datadoghq.com"https://api.us3.datadoghq.com"https://api.us5.datadoghq.com/api/v2/idp/entity_integrations/${integration_id}" \ -H "Accept: application/json" \ -H "Content-Type: application/json" \ -H "Authorization: Bearer ${DD_BEARER_TOKEN}" \ -d @- << EOF { "data": { "attributes": { "config": { "enabled_repos": [ { "github_org_name": "myorg", "hostname": "github.com", "repo_name": "myrepo" } ] } }, "type": "entity_integration_config_requests" } } EOF
## Jira integration configuration #
# Path parameters
export integration_id="github"
# Use a Personal Access Token or Service Access Token
export DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>"

# Curl command
curl -X PUT "https://api.ap1.datadoghq.com"https://api.ap2.datadoghq.com"https://api.datadoghq.eu"https://api.ddog-gov.com"https://api.us2.ddog-gov.com"https://api.uk1.datadoghq.com"https://api.datadoghq.com"https://api.us3.datadoghq.com"https://api.us5.datadoghq.com/api/v2/idp/entity_integrations/${integration_id}" \ -H "Accept: application/json" \ -H "Content-Type: application/json" \ -H "Authorization: Bearer ${DD_BEARER_TOKEN}" \ -d @- << EOF { "data": { "attributes": { "config": { "enabled_projects": [ { "account_id": "123456789", "hostname": "mycompany.atlassian.net", "project_key": "AAA" } ] } }, "type": "entity_integration_config_requests" } } EOF
## PagerDuty integration configuration #
# Path parameters
export integration_id="github"
# Use a Personal Access Token or Service Access Token
export DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>"

# Curl command
curl -X PUT "https://api.ap1.datadoghq.com"https://api.ap2.datadoghq.com"https://api.datadoghq.eu"https://api.ddog-gov.com"https://api.us2.ddog-gov.com"https://api.uk1.datadoghq.com"https://api.datadoghq.com"https://api.us3.datadoghq.com"https://api.us5.datadoghq.com/api/v2/idp/entity_integrations/${integration_id}" \ -H "Accept: application/json" \ -H "Content-Type: application/json" \ -H "Authorization: Bearer ${DD_BEARER_TOKEN}" \ -d @- << EOF { "data": { "attributes": { "config": { "accounts": [ { "enabled": true, "subdomain": "mycompany" } ] } }, "type": "entity_integration_config_requests" } } EOF
"""
Create or update entity integration configuration returns "OK" response
"""

from os import environ
from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.entity_integration_configs_api import EntityIntegrationConfigsApi
from datadog_api_client.v2.model.entity_integration_config_payload import EntityIntegrationConfigPayload
from datadog_api_client.v2.model.entity_integration_config_request import EntityIntegrationConfigRequest
from datadog_api_client.v2.model.entity_integration_config_request_attributes import (
    EntityIntegrationConfigRequestAttributes,
)
from datadog_api_client.v2.model.entity_integration_config_request_data import EntityIntegrationConfigRequestData
from datadog_api_client.v2.model.entity_integration_config_request_type import EntityIntegrationConfigRequestType

body = EntityIntegrationConfigRequest(
    data=EntityIntegrationConfigRequestData(
        attributes=EntityIntegrationConfigRequestAttributes(
            config=EntityIntegrationConfigPayload(
                [("enabled_repos", "[{'github_org_name': 'myorg', 'hostname': 'github.com', 'repo_name': 'myrepo'}]")]
            ),
        ),
        type=EntityIntegrationConfigRequestType.ENTITY_INTEGRATION_CONFIG_REQUESTS,
    ),
)

configuration = Configuration()
configuration.access_token = environ["DD_BEARER_TOKEN"]
configuration.unstable_operations["update_entity_integration_config"] = True
with ApiClient(configuration) as api_client:
    api_instance = EntityIntegrationConfigsApi(api_client)
    response = api_instance.update_entity_integration_config(integration_id="github", body=body)

    print(response)

Instructions

First install the library and its dependencies and then save the example to example.py and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>" python3 "example.py"
# Create or update entity integration configuration returns "OK" response

require "datadog_api_client"
DatadogAPIClient.configure do |config|
  config.access_token = ENV["DD_BEARER_TOKEN"]
  config.unstable_operations["v2.update_entity_integration_config".to_sym] = true
end
api_instance = DatadogAPIClient::V2::EntityIntegrationConfigsAPI.new

body = DatadogAPIClient::V2::EntityIntegrationConfigRequest.new({
  data: DatadogAPIClient::V2::EntityIntegrationConfigRequestData.new({
    attributes: DatadogAPIClient::V2::EntityIntegrationConfigRequestAttributes.new({
      config: DatadogAPIClient::V2::EntityIntegrationConfigPayload.new({}),
    }),
    type: DatadogAPIClient::V2::EntityIntegrationConfigRequestType::ENTITY_INTEGRATION_CONFIG_REQUESTS,
  }),
})
p api_instance.update_entity_integration_config("github", body)

Instructions

First install the library and its dependencies and then save the example to example.rb and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>" rb "example.rb"
// Create or update entity integration configuration returns "OK" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	body := datadogV2.EntityIntegrationConfigRequest{
		Data: datadogV2.EntityIntegrationConfigRequestData{
			Attributes: datadogV2.EntityIntegrationConfigRequestAttributes{
				Config: map[string]interface{}{
					"enabled_repos": "[{'github_org_name': 'myorg', 'hostname': 'github.com', 'repo_name': 'myrepo'}]",
				},
			},
			Type: datadogV2.ENTITYINTEGRATIONCONFIGREQUESTTYPE_ENTITY_INTEGRATION_CONFIG_REQUESTS,
		},
	}
	ctx := datadog.NewDefaultContext(context.Background())
	ctx = context.WithValue(ctx, datadog.ContextAccessToken, os.Getenv("DD_BEARER_TOKEN"))
	configuration := datadog.NewConfiguration()
	configuration.SetUnstableOperationEnabled("v2.UpdateEntityIntegrationConfig", true)
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewEntityIntegrationConfigsApi(apiClient)
	resp, r, err := api.UpdateEntityIntegrationConfig(ctx, "github", body)

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `EntityIntegrationConfigsApi.UpdateEntityIntegrationConfig`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `EntityIntegrationConfigsApi.UpdateEntityIntegrationConfig`:\n%s\n", responseContent)
}

Instructions

First install the library and its dependencies and then save the example to main.go and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>" go run "main.go"
// Create or update entity integration configuration returns "OK" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.EntityIntegrationConfigsApi;
import com.datadog.api.client.v2.model.EntityIntegrationConfigRequest;
import com.datadog.api.client.v2.model.EntityIntegrationConfigRequestAttributes;
import com.datadog.api.client.v2.model.EntityIntegrationConfigRequestData;
import com.datadog.api.client.v2.model.EntityIntegrationConfigRequestType;
import com.datadog.api.client.v2.model.EntityIntegrationConfigResponse;
import java.util.Map;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    defaultClient.setAccessToken(System.getenv("DD_BEARER_TOKEN"));
    defaultClient.setUnstableOperationEnabled("v2.updateEntityIntegrationConfig", true);
    EntityIntegrationConfigsApi apiInstance = new EntityIntegrationConfigsApi(defaultClient);

    EntityIntegrationConfigRequest body =
        new EntityIntegrationConfigRequest()
            .data(
                new EntityIntegrationConfigRequestData()
                    .attributes(
                        new EntityIntegrationConfigRequestAttributes()
                            .config(
                                Map.ofEntries(
                                    Map.entry(
                                        "enabled_repos",
                                        "[{'github_org_name': 'myorg', 'hostname': 'github.com',"
                                            + " 'repo_name': 'myrepo'}]"))))
                    .type(EntityIntegrationConfigRequestType.ENTITY_INTEGRATION_CONFIG_REQUESTS));

    try {
      EntityIntegrationConfigResponse result =
          apiInstance.updateEntityIntegrationConfig("github", body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println(
          "Exception when calling EntityIntegrationConfigsApi#updateEntityIntegrationConfig");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}

Instructions

First install the library and its dependencies and then save the example to Example.java and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>" java "Example.java"
// Create or update entity integration configuration returns "OK" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_entity_integration_configs::EntityIntegrationConfigsAPI;
use datadog_api_client::datadogV2::model::EntityIntegrationConfigRequest;
use datadog_api_client::datadogV2::model::EntityIntegrationConfigRequestAttributes;
use datadog_api_client::datadogV2::model::EntityIntegrationConfigRequestData;
use datadog_api_client::datadogV2::model::EntityIntegrationConfigRequestType;
use std::collections::BTreeMap;

#[tokio::main]
async fn main() {
    let body = EntityIntegrationConfigRequest::new(EntityIntegrationConfigRequestData::new(
        EntityIntegrationConfigRequestAttributes::new(BTreeMap::from([])),
        EntityIntegrationConfigRequestType::ENTITY_INTEGRATION_CONFIG_REQUESTS,
    ));
    let mut configuration = datadog::Configuration::new();
    configuration.set_unstable_operation_enabled("v2.UpdateEntityIntegrationConfig", true);
    let api = EntityIntegrationConfigsAPI::with_config(configuration);
    let resp = api
        .update_entity_integration_config("github".to_string(), body)
        .await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}

Instructions

First install the library and its dependencies and then save the example to src/main.rs and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" cargo run
/**
 * Create or update entity integration configuration returns "OK" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration({
  authMethods: {
    AuthZ: {
      accessToken: process.env.DD_BEARER_TOKEN as string,
    },
  },
});
configuration.unstableOperations["v2.updateEntityIntegrationConfig"] = true;
const apiInstance = new v2.EntityIntegrationConfigsApi(configuration);

const params: v2.EntityIntegrationConfigsApiUpdateEntityIntegrationConfigRequest =
  {
    body: {
      data: {
        attributes: {
          config: {
            enabled_repos:
              "[{'github_org_name': 'myorg', 'hostname': 'github.com', 'repo_name': 'myrepo'}]",
          },
        },
        type: "entity_integration_config_requests",
      },
    },
    integrationId: "github",
  };

apiInstance
  .updateEntityIntegrationConfig(params)
  .then((data: v2.EntityIntegrationConfigResponse) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));

Instructions

First install the library and its dependencies and then save the example to example.ts and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>" tsc "example.ts"